<template>
  <div class="md-layout Blog md-gutter md-alignment-center">
    <h2 class="md-layout-item md-size-100">Blog</h2>

    <md-card v-if="!$route.params.id" v-for="post in this.posts" :key="post.title" class="md-layout-item blog-card">
      <md-card-media>
        <img  @click="openPost(post)" :src="'//localhost:8080' + post.image">
      </md-card-media>

      <md-card-area>
        <md-card-header>
          <div @click="openPost(post)" class="md-title md-primary">{{ post.title }}</div>
          <div class="md-subhead">{{ post.author }} <span md-alignment="right">{{ post.posted | formatDate }}</span></div>
        </md-card-header>

        <md-card-content>
          {{ post.teaser }}
        </md-card-content>
      </md-card-area>

      <md-card-actions>
        <md-button @click="openPost(post)" class="md-icon-button md-accent">
          <md-icon>favorite</md-icon>
        </md-button>

        <md-button class="md-icon-button">
          <md-icon>bookmark</md-icon>
        </md-button>

        <md-button class="md-icon-button">
          <md-icon>share</md-icon>
        </md-button>
      </md-card-actions>
    </md-card>

    <Post v-if="$route.params.id"></Post>
  </div>
</template>

<script>
  import { mapGetters } from 'vuex'
  import Post from '@/components/Post'

  export default {
    name: 'Blog',
    mounted () {
      this.getSampleData()
    },
    components: {Post},
    data () {
      return {
        posts: [],
        errors: [],
        copy: '© a.Signz 18'
      }
    },
    computed: {
      ...mapGetters([
        'api'
      ])
    },
    methods: {
      getSampleData () {
        this.api.get('api/blog/')
          .then(response => {
            // JSON responses are automatically parsed.
            this.posts = response.data
          })
          .catch(e => {
            this.errors.push(e)
            console.log(e)
          })
      },
      openPost (post) {
        console.log('Open', post.id)
        this.$router.push({name: 'Blog', params: {id: post.id}})
      }
    }
  }
</script>

<style lang="scss" scoped>
  .card {
    padding: 0;
  }
</style>

<style lang="scss">
  .card {
    padding: 0;
  }
</style>
